/*
 * Name: SySMon
 * Date: Thu Apr 20 15:12:01 2000
 * Author: pIGpEN [ pigpen@s0ftpj.org, deadhead@sikurezza.org ]
 *
 * SoftProject 2000 - Digital Sekurity for Y2k
 * Sikurezza.org - Italian Security MailingList
 *
 * COFFEE-WARE LICENSE - This source code is like "THE BEER-WARE LICENSE" by
 * Poul-Henning Kamp <phk@FreeBSD.ORG> but you can give me in return a coffee.
 *
 * Tested on: FreeBSD 3.4-RELEASE FreeBSD 3.4-RELEASE #5: Mon Mar i386
 */

#include <stdio.h>
#include <string.h>
#include <sys/syscall.h>
#include <sys/types.h>
#include <sys/module.h>
#include <sys/queue.h>
#include <unistd.h>
#include "sysmon.h"

void	 	usage			__P((void));
void 		add_rule		__P((void));
void 		del_rule		__P((void));
void 		list_rule		__P((void));

int 		findbyname		__P((char *));
void		printcalls		__P((void));
void		menu			__P((void));

#define 	clear			printf("\033[2J\033[1;1H")

void
menu(void)
{
	printf("\n\n--------------------\n"
	       "-- SySMon 1.0Beta --\n"
	       "--------------------\n\n\n");

	printf("1) Add rule\n");
	printf("2) Del rule\n");
	printf("3) List rules\n");
	printf("4) Quit\n\n");
	printf("sysmon> ");
}

int
main(void)
{
	int choice;

	clear;
	
	do {
		menu();
		scanf("%d", &choice);

	
		switch(choice) {
			case 1:
				add_rule();
				break;
			case 2:
				del_rule();
				break;
			case 3:
				list_rule();
				break;
		}

	} while(choice!=4);

	return 0;
}

struct s_sysc {
	char *name;
	int position;
} scall[] = {
	{	"open", 	OPEN 		},
	{	"link",		LINK 		},
	{	"mkfifo",	MKFIFO		},
	{	"mount",	MOUNT		},
	{	"setsockopt",	SETSOCKOPT	},
	{	"seteuid",	SETEUID		},
	{	"socket",	SOCKET		},
#if (__FreeBSD_version < 400000)
	{	"raw",		RIP		},
	{	"udp",		UDP		},
#endif
	{	"unlink",	UNLINK		},
	{	"execve",	EXECVE		},
	{	"setuid",	SETUID		},
	{	"setgid",	SETGID		},
	{	"chmod",	CHMOD		},
	{	"chown",	CHOWN		}
};

void
printcalls(void)
{
	int i;

	for(i=0; i< (sizeof(scall) / sizeof(struct s_sysc)); i++) 
		printf("%s ", scall[i].name);
}

int
findbyname(char *name) 
{
	int i;
	
	for(i = 0; i < ( sizeof(scall) / sizeof(struct s_sysc)); i++)
		if(!strcmp(name, scall[i].name))
			return (scall[i].position);
	
	return (-1);
}

void
add_rule(void)
{
        int syscall_num;
        struct module_stat stat;
	struct s_check r;
	char choice[10];
	int error;

	bzero(&r, 	sizeof r);
	bzero(&choice, 	sizeof choice);
	
	while(strcmp(choice,"uid") && strcmp(choice, "gid")) {
		clear;
		printf("uid or gid ? ->  ");
		scanf("%s", choice);
	}
	
	
	if(!strcmp(choice, "uid")) {
		r.flags = S_UID;
		printf("Uid= ");
	}else{
		r.flags = S_GID;
		printf("Gid= ");
	}

	scanf("%d", &r.id);
	

	while(strcmp(choice, "ok")) {
		int index;
		
		printf("System calls:\n");
		printcalls();
		printf("\n\ncall (ok to exit) > ");
		scanf("%s", choice);
		if(!strcmp(choice, "ok"))
			break;
		if((index = findbyname(choice)) == -1) 
			printf("Syscall %s is not available\n", choice);
		else {
			char action[10];

			bzero(action, sizeof action);

			r.n_call = index;
			
			while(strcmp(action,"block") && strcmp(action,"log")){
				printf("action (block, log): ");
				scanf("%s", action);
			}
				
			if(!strcmp(action, "block"))
				r.n_flags = SYS_BLOCK;
			else
				r.n_flags = SYS_LOG;
			
			r.action = ADD_RULE;

			stat.version = sizeof(stat);
			modstat(modfind("S_Call"), &stat);
			syscall_num = stat.data.intval;

			if((error = syscall(syscall_num, &r)))
				perror("syscall(ADD)");
		}
	}

					
}

void
list_rule(void)
{
	struct s_check r;
	struct module_stat stat;
	int error;
	int syscall_num;

	bzero(&r, sizeof r);

	r.action = LIST_RULE;

	stat.version = sizeof stat;
	modstat(modfind("S_Call"), &stat);
	syscall_num = stat.data.intval;

	if((error = syscall(syscall_num, &r)))
		perror("syscall(LIST)");
}

void
del_rule(void)
{
	struct s_check r;
	struct module_stat stat;
	int syscall_num;
	int error;
	char choice[10];

	bzero(&r, 	sizeof r);
	bzero(choice, 	sizeof choice);

	while(strcmp(choice, "uid") && strcmp(choice, "gid")) {
		clear;
		printf("uid or gid ? -> ");
		scanf("%s", choice);
	}

	if(!strcmp(choice, "uid")) {
		r.flags = S_UID;
		printf("Uid-> ");
	} else {
		r.flags = S_GID;
		printf("Gid-> ");
	}

		
	scanf("%d", &r.id);

	r.action = DEL_RULE;
	
	bzero(choice, sizeof choice);
	while(strcmp(choice,"ok") && strcmp(choice,"all")) {
		int index;
	
	        printf("System calls:\n");
		printcalls();
		printf("\n\ncall (ok to exit, all for global selection) > ");
		scanf("%s", choice);
									                	if(!strcmp(choice, "ok") || !strcmp(choice, "all"))            
			break;
										                if((index = findbyname(choice)) == -1)				                        printf("Syscall %s is not available\n", choice);
		else {
			
			r.n_call = index;
			stat.version = sizeof stat;
			modstat(modfind("S_Call"), &stat);
			syscall_num = stat.data.intval;

			if((error = syscall(syscall_num, &r))) 
				perror("syscall(DEL)");
		}
	}

	if(!strcmp(choice, "all")) {
		r.n_call = 0;
		stat.version = sizeof stat;
		modstat(modfind("S_Call"), &stat);
		syscall_num = stat.data.intval;
		    
		if((error = syscall(syscall_num, &r)))
			perror("syscall(DEL)");
	}
}
