/*
 * Name: SMonitor
 * Date: Sat Apr 15 11:47:13 2000
 * Author: pIGpEN [ pigpen@s0ftpj.org, deadhead@sikurezza.org ]
 *
 * SoftProject 2000 - Digital Sekurity for Y2k
 * Sikurezza.org - Italian Security MailingList
 *
 * COFFEE-WARE LICENSE - This source code is like "THE BEER-WARE LICENSE" by
 * Poul-Henning Kamp <phk@FreeBSD.ORG> but you can give me in return a coffee.
 *
 * Tested on: FreeBSD 3.4-RELEASE FreeBSD 3.4-RELEASE #5: Mon Mar i386
 *	      FreeBSD 4.0-RELEASE Compatible 
 *
 * Special thanks go to: Grace Slick	(for her voice)		oh, yeah!
 *
 * MON_PROTOCOL works with 3.4 Release but not with 4:
 * 	if you include it, there are no changes...
 * 
 * This support was an example created for BFi magazine, It can give you an
 * idea of how you can create and check rules on your kernel support...
 *
 * Note: Even if it works, smonitor is incomplete! so don't consider it a tool
 *	 for your box, see acl(3) (under development) or look for spy at 
 *	 www.freebsd.org if you need of an acl support..
 * 
 */

#define MON_PROTOCOL
#define SKIP_DEVICE
#define SKIP_MOUNTD 

#include <sys/param.h>
#include <sys/proc.h>
#include <sys/module.h>
#include <sys/sysent.h>
#include <sys/syscall.h>
#include <sys/kernel.h>
#include <sys/systm.h>

#include <sys/malloc.h>
#include <sys/mbuf.h>
#include <sys/syslog.h>
#include <sys/sysproto.h>
#include <sys/socket.h>
#include <sys/socketvar.h>


#include <sys/file.h>
#include <sys/fcntl.h>
#include <sys/filio.h>

#ifdef	MON_PROTOCOL
# include <sys/protosw.h>
# include <sys/socket.h>
# include <sys/socketvar.h>
# include <net/if.h>
# include <net/route.h>
# include <netinet/in.h>
# include <netinet/in_systm.h>
# include <netinet/in_pcb.h>
# include <netinet/in_var.h>
# include <netinet/ip_var.h>
#endif

#include "sysmon.h"

static int module_handler __P((module_t, int, void *));
static void log_proc	  __P((struct proc *, char *));
#ifdef	SKIP_DEVICE
static char * strstr	  __P((register char *, register char *));
#endif

/*
 * Syscalls
 */ 

static int s_setsockopt	__P((struct proc *, register struct setsockopt_args *));
static int s_mount	__P((struct proc *, register struct mount_args *));
static int s_open	__P((struct proc *, register struct open_args *));
static int s_link	__P((struct proc *, register struct link_args *));
static int s_mkfifo	__P((struct proc *, register struct mkfifo_args *));
static int s_seteuid	__P((struct proc *, register struct seteuid_args *));
static int s_socket	__P((struct proc *, register struct socket_args *));
static int s_unlink	__P((struct proc *, register struct unlink_args *));
static int s_execve	__P((struct proc *, register struct execve_args *));
static int s_setuid	__P((struct proc *, register struct setuid_args *));
static int s_setgid     __P((struct proc *, register struct setgid_args *));
static int s_chmod	__P((struct proc *, register struct chmod_args *));
static int s_chown      __P((struct proc *, register struct chown_args *));

#if defined(MON_PROTOCOL) && (__FreeBSD_version < 400000)

/*
 * Protocols
 */

static int s_rip_attach		__P((struct socket *, int, struct proc *));
static int (*old_rip_attach)	__P((struct socket *, int, struct proc *));
static int s_udp_attach		__P((struct socket *, int, struct proc *));
static int (*old_udp_attach)	__P((struct socket *, int, struct proc *));

extern struct protosw inetsw[];

#endif

static moduledata_t SysMon = {
	"sysmon",
	module_handler,
	NULL
};

DECLARE_MODULE(sysmon, SysMon, SI_SUB_DRIVERS, SI_ORDER_MIDDLE);

/*
 * Module rules...
 */

LIST_HEAD(,s_rule) s_head;	/* head for our rules */
MALLOC_DEFINE(M_SMON, "SMonitor", "SMonitor chain's");

/*
 * Functions for the chain of Smon 
 */

static void	s_rules_init		__P((void));
static void	s_rules_bye		__P((void));
static int	s_add_entry		__P((struct s_check *));
static int	s_del_entry		__P((struct s_check *));
static int	s_list_entry		__P((struct s_check *));
static int	s_check_entry		__P((struct proc *, int));

static void
s_rules_init(void)
{
	LIST_INIT(&s_head);
}

static void
s_rules_bye(void)
{
	int count = 0;

	while(LIST_FIRST(&s_head)) {
		struct s_rule *pr = LIST_FIRST(&s_head);

		while(LIST_FIRST(&pr->sys_head)) {
			struct s_syscall *scp = LIST_FIRST(&pr->sys_head);

			LIST_REMOVE(LIST_FIRST(&pr->sys_head), sys_chain);
			if(scp) free(scp, M_SMON);
		}
			

		LIST_REMOVE(LIST_FIRST(&s_head), s_chain);
		if(pr) free(pr, M_SMON);
		count++;
	}

	if(count)
		log(LOG_INFO, "[sysmon] unloaded: %d rules erased\n", count);

}
		
/*
 * type = S_UID 
 * 	  S_GID
 *
 */

static int
s_add_entry(struct s_check *check)
{
	struct s_rule *pr, *pnew;
	struct s_syscall *p_ss;

	pnew = malloc(sizeof(struct s_rule), M_SMON, M_NOWAIT);
	bzero(pnew, sizeof(*pnew));

	pnew->s_id 	= check->id;
	pnew->s_flags	= check->flags;

	
	/*
	 * Check if our rule is the first
	 */
	
	if(!s_head.lh_first) {
		p_ss = malloc(sizeof(struct s_syscall), M_SMON, M_NOWAIT);
		bzero(p_ss, sizeof(*p_ss));

		p_ss->sys_call 	= check->n_call;
		p_ss->sys_flags = check->n_flags;
		
		LIST_INSERT_HEAD(&pnew->sys_head, p_ss, sys_chain);
		LIST_INSERT_HEAD(&s_head, pnew, s_chain);
		return 0;
	} else {
		LIST_FOREACH(pr, &s_head, s_chain) {

			/*
			 * check if there is a rule with the same uid / gid
			 */

			if((pr->s_flags == check->flags) && 
					(pr->s_id == check->id)) {
				struct s_syscall *sc;
				
				/*
				 * check if there is the same syscall and modify
				 * it
				 */
				
				LIST_FOREACH(sc, &pr->sys_head, sys_chain) {

					if(sc->sys_call == check->n_call) {
						sc->sys_flags = check->n_flags;
						
						if(pnew) free(pnew, M_SMON);
						return 0;
					}
					

					/*
					 * if it is the last element put new
					 * rule in append to sys_chain
					 */

					if(!sc->sys_chain.le_next) {

						p_ss = malloc(
						       sizeof(struct s_syscall),
						       M_SMON, M_NOWAIT);
						bzero(p_ss, sizeof(*p_ss));

						p_ss->sys_call = check->n_call;
						p_ss->sys_flags= check->n_flags;

						LIST_INSERT_AFTER(sc, p_ss, 
							 sys_chain);

						return 0;
					}
				}
			}
			
			/*
		 	 * attach new rule
		 	 */

			if(!pr->s_chain.le_next) {

				p_ss = malloc(sizeof(struct s_syscall), M_SMON,
						M_NOWAIT);

				bzero(p_ss, sizeof(*p_ss));

				p_ss->sys_call	= check->n_call;
				p_ss->sys_flags = check->n_flags;

				LIST_INSERT_HEAD(&pnew->sys_head, p_ss, 
						sys_chain);
				LIST_INSERT_AFTER(pr, pnew, s_chain);
				return(0);
			}
		}
	}

	/*
	 * Never reached
	 */

	return (-1);
}

/*
 * if n_call is 0 	we wanna delete all syscalls for that uid / gid
 * if n_call is != 0	we wanna delete only that syscall for that uid / gid
 */

static int
s_del_entry(struct s_check *check)
{
	struct s_rule 		*pr;
	struct s_syscall	*sp;

	if(!s_head.lh_first) 
		return (-1);

	
	/*
	 * Delete all syscalls for that rule
	 */

	if(!check->n_call) {
		LIST_FOREACH(pr, &s_head, s_chain) {
			
			if((pr->s_flags == check->flags) && 
					(pr->s_id == check->id)) {
		 		struct s_rule *rp_next;
			
				while(LIST_FIRST(&pr->sys_head)) {
			
					sp = LIST_FIRST(&pr->sys_head);

					LIST_REMOVE(LIST_FIRST(&pr->sys_head), 
							sys_chain);

			    		if(sp) free(sp, M_SMON);
				}

				/*
				 * We don't want a rule without entries
				 */

				rp_next = LIST_NEXT(pr, s_chain);
				LIST_REMOVE(pr, s_chain);
				if(pr) free(pr, M_SMON);
				pr = rp_next;
				return 0;
			}
		}
	}
	
	/*
	 * Delete only a syscall for that rule
	 */
		
	if(check->n_call > 0) {		
		LIST_FOREACH(pr, &s_head, s_chain) {

			if((pr->s_flags == check->flags) &&
					(pr->s_id == check->id)) {

				LIST_FOREACH(sp, &pr->sys_head, sys_chain) {
					if(check->n_call == sp->sys_call) {
						struct s_syscall *sp_next;
					 
			  			sp_next = LIST_NEXT(sp, 
								sys_chain);
						
			  			LIST_REMOVE(sp, sys_chain);
			  		
						if(sp) free(sp, M_SMON);

						sp = sp_next;

					  	/*
					  	 * we don't want a rule without 
					  	 * entries
					  	 */

						if(!pr->sys_head.lh_first) {
					   		struct s_rule *rp_next;

					   		rp_next = 
							 LIST_NEXT(pr, s_chain);
					   		
							LIST_REMOVE(pr,s_chain);
					   		if(pr) free(pr, M_SMON);
							pr = rp_next; 
						}

						return 0;
					}
				}
			}
		}
	}
	
	return (-1);
}

/*
 * Temporary s_list_entry...
 * This function writes directly from kernel... with printf()
 * Yeah it sucks... but I have no time...
 */

static int
s_list_entry(struct s_check *check)
{
	register struct s_rule	*pr;

        if(!s_head.lh_first)
                return (-1);
		

	LIST_FOREACH(pr, &s_head, s_chain) {
		register struct s_syscall *sp;

		if(pr->s_flags == S_UID)
			printf("uid-> ");
		if(pr->s_flags == S_GID)
			printf("gid-> ");
			
		printf("%d\n", pr->s_id);
			

		LIST_FOREACH(sp, &pr->sys_head, sys_chain) {
			printf("\tcall-> %d ", sp->sys_call);
			printf("flags-> ");
			if(sp->sys_flags == SYS_LOG)
				printf("log\n");
			if(sp->sys_flags == SYS_BLOCK)
				printf("block\n");
		}
	}

	return 0;
}
	

/*
 * return 	-1 if SysMon is not active for that syscall
 * 		 0 if active
 * 		 1 if block
 * 		
 */

static int
s_check_entry(struct proc *p, int pos)
{
	register struct s_rule 		*rp;
	register struct s_syscall 	*sp;

	

	LIST_FOREACH(rp, &s_head, s_chain) {
		if( (rp->s_id == p->p_cred->p_ruid)  ||
				(rp->s_id == p->p_cred->p_rgid) ) {

			LIST_FOREACH(sp, &rp->sys_head, sys_chain) {

				if(pos == sp->sys_call) {
					switch(sp->sys_flags) {
						case SYS_LOG:
								return 0;
						case SYS_BLOCK:
								return 1;
					}
				}
			}
		}
	}
	
	return (-1);
}


/*
 * Module handler
 */


static int
module_handler(module_t mod, int cmd, void *arg)
{
#if defined(MON_PROTOCOL) && (__FreeBSD_version < 400000)
	int s;
#define attach(x)	inetsw[ip_protox[x]].pr_usrreqs->pru_attach
#endif
	switch(cmd) {
		case MOD_LOAD:
		 printf("--SysMon v1.0beta Loaded--\n");
		 s_rules_init();
		 sysent[SYS_setsockopt].sy_call = (sy_call_t *) s_setsockopt;
		 sysent[SYS_mount].sy_call	= (sy_call_t *) s_mount; 
		 sysent[SYS_open].sy_call	= (sy_call_t *) s_open;
		 sysent[SYS_link].sy_call	= (sy_call_t *) s_link;
		 sysent[SYS_mkfifo].sy_call	= (sy_call_t *) s_mkfifo;
		 sysent[SYS_seteuid].sy_call	= (sy_call_t *) s_seteuid;
		 sysent[SYS_socket].sy_call	= (sy_call_t *) s_socket;
		 sysent[SYS_unlink].sy_call	= (sy_call_t *) s_unlink;
		 sysent[SYS_execve].sy_call	= (sy_call_t *) s_execve;
		 sysent[SYS_setuid].sy_call	= (sy_call_t *) s_setuid;
		 sysent[SYS_setgid].sy_call	= (sy_call_t *) s_setgid;
		 sysent[SYS_chmod].sy_call	= (sy_call_t *) s_chmod;
		 sysent[SYS_chown].sy_call	= (sy_call_t *) s_chown;
#if defined(MON_PROTOCOL) && (__FreeBSD_version < 400000)
		 s = splnet();
		 old_rip_attach			= attach(IPPROTO_RAW);
		 attach(IPPROTO_RAW)		= s_rip_attach;
		 attach(IPPROTO_ICMP)		= s_rip_attach;
		 attach(IPPROTO_IGMP)		= s_rip_attach;
		 attach(IPPROTO_IPIP)		= s_rip_attach;
		 old_udp_attach			= attach(IPPROTO_UDP);
		 attach(IPPROTO_UDP)		= s_udp_attach;
		 splx(s);
#endif
		 break;
		 
		 
		case MOD_UNLOAD:
		 printf("--SysMon v1.0beta Unloaded--\n");
		 sysent[SYS_setsockopt].sy_call = (sy_call_t *) setsockopt;
		 sysent[SYS_mount].sy_call	= (sy_call_t *) mount;
		 sysent[SYS_open].sy_call	= (sy_call_t *) open;
		 sysent[SYS_link].sy_call	= (sy_call_t *) link; 
		 sysent[SYS_mkfifo].sy_call	= (sy_call_t *) mkfifo;
		 sysent[SYS_seteuid].sy_call	= (sy_call_t *) seteuid;
		 sysent[SYS_socket].sy_call	= (sy_call_t *) socket;
		 sysent[SYS_unlink].sy_call	= (sy_call_t *) unlink;
		 sysent[SYS_execve].sy_call	= (sy_call_t *) execve;
		 sysent[SYS_setuid].sy_call	= (sy_call_t *) setuid;
		 sysent[SYS_setgid].sy_call	= (sy_call_t *) setgid;
		 sysent[SYS_chmod].sy_call	= (sy_call_t *) chmod;
		 sysent[SYS_chown].sy_call	= (sy_call_t *) chown;
#if defined(MON_PROTOCOL) && (__FreeBSD_version < 400000)
		 s = splnet();
		 attach(IPPROTO_RAW)		= old_rip_attach;
		 attach(IPPROTO_ICMP)		= old_rip_attach;
		 attach(IPPROTO_IGMP)		= old_rip_attach;
		 attach(IPPROTO_IPIP)		= old_rip_attach;
		 attach(IPPROTO_UDP)		= old_udp_attach;
		 splx(s);
#endif
		 s_rules_bye();		 
	 	 break;
	}

	return 0;
}

/*
 * SYSCALL MODULE
 *
 * This part implements a new syscall to interface this support with your
 * system
 *
 */


#define	PAD_(t)	(sizeof(register_t) <= sizeof(t) ? \
				0 : sizeof(register_t) - sizeof(t))

struct sctl_args {
	struct s_check *check;	char check_[PAD_(struct s_check *)];
};


static int	S_ctl	__P((struct proc *, struct sctl_args *));

static struct sysent S_sysent = {
	1,
	(sy_call_t *) S_ctl
};

#define MAX_ID	32000

static int
S_ctl(struct proc *p, struct sctl_args *r)
{
	int	error; 

	/*
	 * check permission
	 */
#if (__FreeBSD_version < 400000)
	if((error = suser(p->p_ucred, &p->p_acflag))) 
#else
	if((error = suser(p)))
#endif
		return (error);
	/*
	 * check params
	 */

	if(r->check->action != LIST_RULE) {
		
		if(r->check->id < 0 || r->check->id > MAX_ID)
			return(EINVAL);
	
		if((r->check->n_call < 0) || r->check->n_call > LAST_CALL)
			return(EINVAL);

		if((r->check->action != DEL_RULE) && (!r->check->n_call))
			return(EINVAL);

		if((r->check->flags != S_UID) && (r->check->flags != S_GID)) 
			return(EINVAL);

		if((r->check->action != DEL_RULE) && 
		   	(r->check->n_flags != SYS_BLOCK) &&
		   		(r->check->n_flags != SYS_LOG))
			return(EINVAL);
	}
	
	switch(r->check->action) {
		
		case DEL_RULE:	
				if(s_del_entry(r->check) == -1)
					return(EINVAL);
				break;
		case ADD_RULE:
				if(s_add_entry(r->check) == -1)
					return(EINVAL);
				break;
		case LIST_RULE:
				if(s_list_entry(r->check) == -1)
					return(EINVAL);
				break;
		default:
				return(EINVAL);
	}

	return 0;
}

static int offset = NO_SYSCALL;


static int	S_Handle	__P((struct module *, int, void *));

static int
S_Handle(struct module *mod, int cmd, void *arg)
{
	return 0;
}


SYSCALL_MODULE(S_Call, &offset, &S_sysent, S_Handle, NULL);

static void 
log_proc(struct proc *p, char *name)
{
	log(LOG_INFO, "[sysmon]: %s (id=%d, uid=%d name=%s)\n", 
			name, p->p_pid, p->p_cred->p_ruid, p->p_comm);
}

/*
 * System calls
 */ 

static int
s_setsockopt(struct proc *p, register struct setsockopt_args *uap)
{
	register int val;
	
	if((val = s_check_entry(p, SETSOCKOPT)) != -1) {
		log_proc(p, "setsockopt()");
		log(LOG_INFO, "setsockopt(level=%d,name=%d)\n", 
				uap->level, uap->name);
		if(val == 1) {
			log(LOG_INFO, "setsockopt prohibited!");
			return EPERM;
		}
	}
	
	return(setsockopt(p, uap));
}


#ifdef SKIP_MOUNTD

/*
 * Don't change this if you don't know what it does...
 */
	#define 	MOUNTD_NAME		"mountd"

#endif

static int
s_mount(struct proc *p, register struct mount_args *uap)
{
#ifdef SKIP_MOUNTD
	struct proc *p1;
	pid_t mountd_id = 0; 

	
	LIST_FOREACH(p1, &allproc, p_list) {
		if(!strcmp(p1->p_comm, MOUNTD_NAME)) 
			mountd_id = p1->p_pid;
	}

	if(p->p_pid != mountd_id) {
#endif
		if(s_check_entry(p, MOUNT) != -1) {
			log_proc(p, "mount()");
			log(LOG_INFO, "mount(type=%s, dir=%s, flags=%x)\n",
					uap->type, uap->path, uap->flags);
		}
#ifdef SKIP_MOUNTD		
	}
#endif
	
	return(mount(p, uap));
}

/*
 * This function doesn't use SYS_BLOCK....
 */

static int
s_open(struct proc *p, register struct open_args *uap)
{
#ifdef SKIP_DEVICE	
	if(!strstr(uap->path, "/dev/")) {
#endif
		if(s_check_entry(p, OPEN) != -1) {
			log_proc(p, "open()");
			log(LOG_INFO, "open(path=%s, flags=%x, mode=%x)\n",
				uap->path, uap->flags, uap->mode);
		} 
#ifdef SKIP_DEVICE		
	}
#endif	

	return(open(p, uap));
}

#ifdef SKIP_DEVICE
static char *
strstr(s, find)
	register char *s, *find;
{
	register char c, sc;
	register size_t len;

	if ((c = *find++) != 0) {
		len = strlen(find);
		do {
			do {
				if ((sc = *s++) == 0)
					return (NULL);
			} while (sc != c);
		} while (strncmp(s, find, len) != 0);
		s--;
	}
	return ((char *)s);
}
#endif


static int
s_link(struct proc *p, struct link_args *uap)
{
	register int val;
	
	if((val = s_check_entry(p, LINK)) != -1) {
		log_proc(p, "link()");
		log(LOG_INFO, "link(path=%s, link=%s)\n", uap->path, uap->link);
		
		if(val == 1) {
			log(LOG_INFO, "link prohibited!\n");
			return EPERM;
		}
	}

	return(link(p, uap));
}

static int
s_mkfifo(struct proc *p, struct mkfifo_args *uap)
{
	register int val;

	if((val = s_check_entry(p, MKFIFO)) != -1) {
	
		log_proc(p, "mkfifo()");
		log(LOG_INFO, "mkfifo(path=%s, mode=%d)\n",
				uap->path, uap->mode);

		if(val == 1) {
			log(LOG_INFO, "mkfifo prohibited!\n");
			return EPERM;
		}
	}

	return(mkfifo(p, uap));
}

static int
s_seteuid(struct proc *p, struct seteuid_args *uap)
{
	register int val;

	if((val = s_check_entry(p, SETEUID)) != -1) {
		
		log_proc(p, "seteuid()");
		log(LOG_INFO, "seteuid(%d)\n", uap->euid);

		if(val == 1) {
			log(LOG_INFO, "seteuid prohibited!\n");
			return EPERM;
		}
	}

	return(seteuid(p, uap));
}

static int
s_socket(struct proc *p, struct socket_args *uap)
{
	register int val;

	if((val = s_check_entry(p, SOCKET)) != -1) {

		log_proc(p, "socket()");
		log(LOG_INFO, "socket(%d, %d, %d)\n", 
				uap->domain, uap->type, uap->protocol);

		if(val == 1) {
			log(LOG_INFO, "socket prohibited!\n");
			return EPERM;
		}
	}

	return(socket(p, uap));
}


#if defined(MON_PROTOCOL) && (__FreeBSD_version < 400000)
static int
s_udp_attach(struct socket *so, int proto, struct proc *p)
{
	register int val;
	
	if((val = s_check_entry(p, UDP)) != -1) {
		log_proc(p, "udp_attach()");

		if(val == 1) {
			log(LOG_INFO, "udp prohibited!\n");
			return EPERM;
		}
	}
		
	return((*old_udp_attach)(so, proto, p));
}

/*
 * rip_attach() requires super user... 
 * there is no sense to block it... it is only logged
 */

static u_long	rip_sendspace = 8192;	/* RIPSNDQ */
static u_long	rip_recvspace = 8192;	/* RIPRCVQ */

extern struct inpcbinfo ripcbinfo;
	  
static int
s_rip_attach(struct socket *so, int proto, struct proc *p)
{
	struct inpcb *inp;
	int error, s;

	inp = sotoinpcb(so);
	
	if (inp)
		panic("rip_attach");
	if (p && (error = suser(p->p_ucred, &p->p_acflag)) != 0)
		return error;

        if(s_check_entry(p, RIP) != -1) 
	        log_proc(p, "rip_attach()");

	s = splnet();
	error = in_pcballoc(so, &ripcbinfo, p); 					splx(s);
	if (error)
		return error;
	error = soreserve(so, rip_sendspace, rip_recvspace);
	if (error)
		return error;
	inp = (struct inpcb *)so->so_pcb;
	inp->inp_ip_p = proto;
	return 0;
}
#endif	/* __FreeBSD_version */

/*
 * Further syscalls
 */

static int
s_unlink(struct proc *p, register struct unlink_args *uap)
{
        register int val;

        if((val = s_check_entry(p, UNLINK)) != -1) {
	        log_proc(p, "unlink()");
	        log(LOG_INFO, "unlink(path=%s)\n", uap->path);

		if(val == 1) {
			log(LOG_INFO, "unlink prohibited!\n");
			return EPERM;
		}
	}

	return(unlink(p, uap));
}

/*
 * Only log is allowed for these syscalls
 */

static int
s_execve(struct proc *p, register struct execve_args *uap)
{
	if(s_check_entry(p, EXECVE) != -1) {
		log_proc(p, "execve()");
		log(LOG_INFO, "execve(name=%s)\n", uap->fname);
		
	}

	return(execve(p, uap));
}

static int
s_setuid(struct proc *p, register struct setuid_args *uap)
{
	if(s_check_entry(p, SETUID) != -1) {
		log_proc(p, "setuid()");
		log(LOG_INFO, "setuid(name=%d)\n", uap->uid);
	}

	return(setuid(p, uap));
}

static int
s_setgid(struct proc *p, register struct setgid_args *uap)
{
	if(s_check_entry(p, SETGID) != -1) {
		log_proc(p, "setgid()");
                log(LOG_INFO, "setgid(name=%d)\n", uap->gid);
        }

        return(setgid(p, uap));
}

/*
 * Log and block
 */

static int
s_chmod(struct proc *p, register struct chmod_args *uap)
{
	register int val;

	if((val = s_check_entry(p, CHMOD)) != -1) {
		log_proc(p, "chmod()");
		log(LOG_INFO, "chmod(path=%s mode=%o)\n", uap->path, uap->mode);

		if(val == 1) {
			log(LOG_INFO, "chmod prohibited!\n");
			return EPERM;
		}
	}

	return(chmod(p, uap));
}
	
static int
s_chown(struct proc *p, register struct chown_args *uap)
{
	register int val;

	if((val = s_check_entry(p, CHOWN)) != -1) {
		log_proc(p, "chown()");
		log(LOG_INFO, "chown(path=%s uid=%d gid=%d)\n", 
			uap->path, uap->uid, uap->gid);
	
		if(val == 1) {
			log(LOG_INFO, "chown prohibited!\n");
			return EPERM;
		}
	}

	return(chown(p, uap));
}
