/*
 * Name: sysmon.h
 * Date: Sun Apr 16 13:10:07 2000
 * Author: pIGpEN [ pigpen@s0ftpj.org, deadhead@sikurezza.org ]
 *
 * SoftProject 2000 - Digital Sekurity for Y2k
 * Sikurezza.org - Italian Security MailingList
 *
 * COFFEE-WARE LICENSE - This source code is like "THE BEER-WARE LICENSE" by
 * Poul-Henning Kamp <phk@FreeBSD.ORG> but you can give me in return a coffee.
 *
 * Tested on: FreeBSD 3.4-RELEASE FreeBSD 3.4-RELEASE #5: Mon Mar i386
 */

#if defined(KERNEL) || defined(_KERNEL)

/*
 * KERNEL STRUCTURES & FLAGS
 */

struct s_syscall {
	LIST_ENTRY(s_syscall) sys_chain;	/* syscall entry */
	int  sys_call;				/* syscall type */
	int  sys_flags;				/* syscall flags */
};


struct s_rule {
	uid_t	s_id;
	int	s_flags;
	LIST_ENTRY(s_rule)	s_chain;
	LIST_HEAD(,s_syscall)	sys_head; 
};

#else
# include <sys/param.h>
#endif


#define 	SYS_LOG		1
#define		SYS_BLOCK	2


/* s_flags */

#define		S_UID		1	
#define		S_GID		2

/*
 * Syscall type (used for n_call and for s_flags & sys_call)
 */

#define		OPEN		1	
#define		LINK		2
#define		MKFIFO		3
#define		MOUNT		4
#define		SETSOCKOPT	5
#define		SETEUID		6
#define		SOCKET		7
#define		UNLINK		8
#define		EXECVE		9
#define		SETUID		10
#define		SETGID		11
#define		CHMOD		12
#define		CHOWN		13
#if defined(MON_PROTOCOL) && (__FreeBSD_version<400000)
# define	RIP		14
# define	UDP		15
# define	LAST_CALL	15
#else
# define	LAST_CALL	13
#endif

/*
 * Structure used to pass actions from user-level to kernel-level
 */

struct s_check {
	int id;		/* uid or gid 		*/
	int flags;	/* s_uid or s_gid 	*/
	int n_call; 	/* OPEN, LINK ... 	*/
	int n_flags;	/* log, block 		*/
	int action;	/* ADD_RULE, DEL_RULE..	*/
};

/* id */

#define ADD_RULE	1
#define DEL_RULE	2
#define LIST_RULE	3
